(document:surround "/std/frame")
(document:insert "/std/functions")

(define *start* (make-cell 1))
(define *size* (make-cell 1))

;;; Functions
(define (do-apply data)
  (cell-set! *start* (woo-get-option data 'start))
  (cell-set! *size* (woo-get-option data 'size))
  (txt text (woo-get-option data 'text))
  (range text (woo-get-option data 'range)))

(define (do-update . args)
  (woo-catch/message
    (thunk
      (do-apply (apply woo-read-first "/logs" 
				  'start (cell-ref *start*)
				  'size (cell-ref *size*)
				  'name (log value)
				  args)))))

;;; UI
(hbox align "left"
      (label text (_ "Logs:"))
      (document:id log (combobox (when selected (do-update)))))
(document:id txt (textbox))
(hbox align "left"
      (document:id range (label))
      (button text (_ "Previous") (when clicked (do-update 'back #t)))
      (button text (_ "Next") (when clicked (do-update 'next #t)))
      (label)
      (button text (_ "First page") (when clicked (do-update 'first #t)))
      (button text (_ "Last page") (when clicked (do-update 'last #t)))
      (label text "|")
      (label text (_ "Show:"))
      (document:id new_size (combobox (when selected (do-update 'new_size (new_size value))))))

;;; Logic
(document:root
  (when loaded
    (woo-catch/message
      (thunk
	(let ((data (woo-read-first "/logs")))
	  (log enumref "/logs/avail_log"
	       value (woo-get-option data 'name))
	  (new_size enumref "/logs/avail_size"
	            value (woo-get-option data 'new_size))

	  (do-apply data))))))
